/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2017 Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * Tempura solution to the "Towers of Hanoi" problem (Roger Hale) 
 *
 */

define hanoi(n) = exists L,C,R : {
    list(L,n) and forall i<n : L[i]=i and
    C=[] and R=[] and
    move(n,L,C,R) and
    always format("L=%10t C=%10t R=%10t\n",L,C,R)
}.

/* Move n discs from peg A to peg B */
define move(n,A,B,C) = {
    if n=0 then empty
    else {
	move(n-1,A,C,B);
	{
	    skip and A:=A[1..|A|] and B:=A[0..1]+B and C:=C
	};
	move(n-1,C,B,A)
    }
}.

run hanoi(4).
