/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2017 Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * Miscellaneous functions for C interpreter.
 * Roger Hale
 */

define is_integer(A) = {
    type(A) = "integer"
}.

define is_boolean(A) = {
    type(A) = "boolean"
}.

define is_nil(A) = {
    type(A) = "nil"
}.

define is_list(A) = {
    type(A) = "list"
}.

define is_string(A) = {
    type(A) = "string"
}.

define is_pointer(A) = {
    type(A) = "pointer"
}.

define is_lambda(A) = {
    type(A) = "lambda"
}.

define is_digit(S) = {
    "0" <= S and S <= "9"
}.

define wave(A) = {
    if A=0 then "|  " else "  |"
}.

define keep_stable(X) = exists x:{keep(X=x)}.
